#!/system/bin/bash

##############################################################################
# Android 下位机升级脚本,必须以 root 权限执行
# param1 表示升级包所在路径,比如 U 盘. 然后解压在复制和安装 apk
# param2 表示是否删除之前版本, 实现降版本功能
#############################################################################
# Make sure only root can run our script
if [[ $EUID -ne 0 ]]; then
	echo "YOU must be as root" 1>&2
	exit 1
fi

#build_out=DS70000Update.GEL
####################################################################################
# Temp dir for upgrading
####################################################################################
UPDATE_SOURCE=/mnt/tmp
UPDATE_BAKUP=/mnt/bak
UPDATE_SHELL=$UPDATE_SOURCE/shell/do_extract.sh

mkdir -p $UPDATE_SOURCE
mkdir -p $UPDATE_BAKUP

####################################################################################
# Upgradation Package from param1
####################################################################################
UPDATE_PACKAGE=$(realpath $1)

####################################################################################
# unpackage if Param is GEL
####################################################################################
if [ ! -f $UPDATE_PACKAGE ]; then
	echo 'Invalid GEL file'
	exit 1
fi

echo "Update ..."
cd $UPDATE_SOURCE
# tar --no-same-owner -xvf $UPDATE_PACKAGE >/dev/null 2>&1
/system/bin/busybox tar  -xvf $UPDATE_PACKAGE >/dev/null 2>&1
if [ $? -ne 0 ]; then
	echo 'Execute tar command failed !'
	exit 1
fi

####################################################################################
# COPY FILES
####################################################################################
$UPDATE_SHELL $2

