#!/system/bin/bash

# Make sure only root can run our script
if [[ $EUID -ne 0 ]]; then
	echo "This script must be run as root" 1>&2
	exit 1
fi

# insmod pcie-rockchip.ko
lsmod | grep pcie_rockchip
if [ $? -eq 0 ]; then
	echo "pcie-rockchip have loaded"
else
	insmod /rigol/driver/pcie-rockchip.ko
fi

# insmod xdma.ko
lsmod | grep xdma
if [ $? -eq 0 ]; then
	echo "xdma have loader"
else
    echo "insmod /rigol/driver/xdma.ko"
    insmod /rigol/driver/xdma.ko
fi

sleep 1
chmod 777 /dev/xdma0_*

if [ ! $? == 0 ]; then
	echo "Error: Kernel module did not load properly."
	echo " FAILED"
	exit 1
fi

# Check to see if the xdma devices were recognized
echo ""
cat /proc/devices | grep xdma > /dev/null
returnVal=$?
if [ $returnVal == 0 ]; then
	# Installed devices were recognized.
	echo "The Kernel module installed correctly and the xmda devices were recognized."
else
	# No devices were installed.
	echo "Error: The Kernel module installed correctly, but no devices were recognized."
	echo " FAILED"
	exit 1
fi

echo "DONE"
