#!/system/bin/bash

function usage() {
    local script_name=$0
    echo -e "\nUsage:
    $script_name
    $script_name  -h
    $script_name  --help

    $script_name  --default
    $script_name  /rigol/FPGA/BOOT.bit  0x400000 
    $script_name  /rigol/FPGA/BOOT.bit  0x800000 
    "
    return
}

[[ "$1" == "" || "$1" == "-h" || "$1" == "--help" ]] && usage && exit 0

default_fw_path=/rigol/FPGA/BOOT.bit
default_download_addr=0x000000

if [[ x"$1" == x"--default" ]]; then
    download_addr=${default_download_addr}
else
    if [[ x"$2" == x"" ]]; then
        usage && exit 0
    fi

    fw_path=$1
    download_addr=$2

    /rigol/tools/get_current_time
    echo /rigol/tools/spi2erase ${fw_path} ${download_addr}
    /rigol/tools/spi2erase ${fw_path} ${download_addr}
    echo

    /rigol/tools/get_current_time
    echo /rigol/tools/spi2flash ${fw_path} ${download_addr}
    /rigol/tools/spi2flash ${fw_path} ${download_addr}
    echo

    /rigol/tools/get_current_time
    echo 
fi

pushd /rigol/driver/ > /dev/null
    kill -9 $(pidof com.rigol.scope)
    sleep 1
    rmmod xdma
    rmmod pcie_rockchip

    echo /rigol/tools/spi2boot ${download_addr}
    /rigol/tools/spi2boot ${download_addr}

    sleep 10
    insmod pcie-rockchip.ko
    insmod xdma.ko
    sleep 2
    chmod 777 /dev/xdma*

    if [[ -f /dev/xdma0_control ]]; then
        setprop persist.rigol.fpga.boot.addr ${download_addr}
    else
        setprop persist.rigol.fpga.boot.addr ${default_download_addr}
    fi

popd  > /dev/null

echo
lspci

echo
/rigol/tools/pcie2dev 0x4000

